%global momorel 2

Summary: Statically linked binary providing simplified versions of system commands
Name: busybox
Version: 1.9.1
Release: %{momorel}m%{?dist}
License: GPL
Group: System Environment/Shells
Source0: http://www.busybox.net/downloads/%{name}-%{version}.tar.bz2 
#NoSource: 0
Source1: busybox-petitboot.config
Patch: busybox-1.5.1-static.patch
Patch1: busybox-1.5.1-anaconda.patch
Patch4: busybox-1.2.0-ppc64.patch
Patch11: busybox-1.2.2-iptunnel.patch
Patch12: busybox-1.2.2-ls.patch
Patch13: busybox-1.5.1-clean.patch
Patch14: busybox-1.9.0-msh.patch
Patch15: busybox-1.9.0-gc-section.patch
Patch16: busybox-1.9.0-hwclock.patch
Patch17: busybox-1.9.1-headers.patch

URL: http://www.busybox.net/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%define debug_package %{nil}

%package anaconda
Group: System Environment/Shells
Summary: Version of busybox configured for use with anaconda

%package petitboot
Group: System Environment/Shells
Summary: Version of busybox configured for use with petitboot

%description 
Busybox is a single binary which includes versions of a large number
of system commands, including a shell.  This package can be very
useful for recovering from certain types of system failures,
particularly those involving broken shared libraries.

%description anaconda
Busybox is a single binary which includes versions of a large number
of system commands, including a shell.  The version contained in this
package is designed for use with the Red Hat installation program,
anaconda. The busybox package provides a binary better suited to
normal use.

%description petitboot
Busybox is a single binary which includes versions of a large number
of system commands, including a shell.  The version contained in this
package is a minimal configuration intended for use with the Petitboot
bootloader used on PlayStation 3. The busybox package provides a binary
better suited to normal use.


%prep
%setup -q 
%patch13 -b .clean -p1
%patch -b .static -p1
%patch11 -b .iptunnel -p1
%patch12 -b .ls -p1
%patch14 -b .msh -p1
%patch15 -b .sect -p1
%patch16 -b .ia64 -p1
%patch17 -b .head -p1

%build
make defconfig
make CC="gcc $RPM_OPT_FLAGS"
cp busybox busybox-static

# create busybox optimized for anaconda
patch -R -p1 <%{PATCH0}
patch -R -p1 <%{PATCH15}
# applied anaconda patch
patch -b --suffix .anaconda -p1 < %{PATCH1}
make defconfig
make CONFIG_DEBUG=y CC="gcc $RPM_OPT_FLAGS"
cp busybox busybox.anaconda

#create busybox optimized for petitboot
make clean
# copy new configuration file
cp %{SOURCE1} .config
# .config file has to be recreated to the new format
yes "" | make oldconfig
make CC="%__cc $RPM_OPT_FLAGS"
cp busybox busybox.petitboot

%install
rm -rf --preserve-root %{buildroot}
mkdir -p %{buildroot}/sbin
install -s -m 755 busybox-static %{buildroot}/sbin/busybox
install -m 755 busybox.anaconda $RPM_BUILD_ROOT/sbin/busybox.anaconda
install -m 755 busybox.petitboot $RPM_BUILD_ROOT/sbin/busybox.petitboot

%clean
rm -rf --preserve-root %{buildroot}

%files
%defattr(-,root,root)
/sbin/busybox

%files anaconda
%defattr(-,root,root)
%doc LICENSE docs/busybox.net/*.html docs/busybox.net/images/*
/sbin/busybox.anaconda

%files petitboot
%doc LICENSE 
%defattr(-,root,root,-)
/sbin/busybox.petitboot

%changelog
* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.9.1-2m)
- rebuild against gcc43

* Thu Mar 27 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (1.9.1-1m)
- update 1.9.1

* Wed Feb 13 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (1.7.2-2m)
- %%NoSource -> NoSource

* Mon Oct 22 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.7.2-1m)
- update 1.7.2
- import fedora patch

* Mon Jan 22 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.2.2-2m)
- import fedora patch
- cleanup spec

* Mon Jan 02 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (1.01-2m)
- update busybox-selinux.patch

* Sat Dec 24 2005 Yohsuke Ooi <meke@momonga-linux.org>
- (1.01-1m)
- ver up 1.01 

* Mon Feb 14 2005 Toru Hoshina <t@momonga-linux.org>
- (1.00-0.020050214.1m)
- ver up.

* Mon Apr 26 2004 Toru Hoshina <t@momonga-linux.org>
- (0.60.5-6m)
- import from FC1, again :-p

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Mon Jan 13 2003 Jeremy Katz <katzj@redhat.com> 0.60.5-5
- lost nolock for anaconda mount when rediffing, it returns (#81764)

* Mon Jan 6 2003 Dan Walsh <dwalsh@redhat.com> 0.60.5-4
- Upstream developers wanted to eliminate the use of floats

* Thu Jan 3 2003 Dan Walsh <dwalsh@redhat.com> 0.60.5-3
- Fix free to work on large memory machines.

* Sat Dec 28 2002 Jeremy Katz <katzj@redhat.com> 0.60.5-2
- update Config.h for anaconda build to include more useful utils

* Thu Dec 19 2002 Dan Walsh <dwalsh@redhat.com> 0.60.5-1
- update latest release

* Thu Dec 19 2002 Dan Walsh <dwalsh@redhat.com> 0.60.2-8
- incorporate hammer changes

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon May 06 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- fix compilation on mainframe

* Tue Apr  2 2002 Jeremy Katz <katzj@redhat.com>
- fix static busybox (#60701)

* Thu Feb 28 2002 Jeremy Katz <katzj@redhat.com>
- don't include mknod in busybox.anaconda so we get collage mknod

* Fri Feb 22 2002 Jeremy Katz <katzj@redhat.com>
- rebuild in new environment

* Wed Jan 30 2002 Jeremy Katz <katzj@redhat.com>
- update to 0.60.2
- include more pieces for the anaconda version so that collage can go away
- make the mount in busybox.anaconda default to -onolock

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
`- automated rebuild

* Mon Jul  9 2001 Tim Powers <timp@redhat.com>
- don't obsolete sash
- fix URL and spelling in desc. to satisfy rpmlint

* Thu Jul 05 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- add missing defattr for anaconda subpackage

* Thu Jun 28 2001 Erik Troan <ewt@redhat.com>
- initial build for Red Hat
